diff --git a/testsuite/serpent-test.c b/testsuite/serpent-test.c
index d9e193b..715482c 100644
--- a/testsuite/serpent-test.c
+++ b/testsuite/serpent-test.c
@@ -19,31 +19,55 @@ decode_hex_reverse (const char *hex)
   return p;
 }
 
-#define RH(x) decode_hex_reverse(x)
-#define RHL(x) decode_hex_length(x), decode_hex_reverse(x)
+void
+test_cipher_reverse(const struct nettle_cipher *cipher,
+	    const uint8_t *key_hex,
+	    const uint8_t *cleartext_hex,
+	    const uint8_t *ciphertext_hex)
+{
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_reverse(key_hex);
+  unsigned cleartext_length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_reverse(cleartext_hex);
+  unsigned ciphertext_length = decode_hex_length(ciphertext_hex);
+  const uint8_t *ciphertext = decode_hex_reverse(ciphertext_hex);
+
+  key_hex = encode_hex_dup(key, key_length);
+  cleartext_hex = encode_hex_dup(cleartext, cleartext_length);
+  ciphertext_hex = encode_hex_dup(ciphertext, ciphertext_length);
+
+  test_cipher(cipher, key_hex, cleartext_hex, ciphertext_hex);
+
+  free((void *)ciphertext_hex);
+  free((void *)cleartext_hex);
+  free((void *)key_hex);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
+}
 
 int
 test_main(void)
 {
   /* From libgcrypt */
   test_cipher(&nettle_serpent128,
-	      HL("0000000000000000 0000000000000000"),
-	      HL("D29D576FCEA3A3A7 ED9099F29273D78E"),
-	      H("B2288B968AE8B086 48D1CE9606FD992D"));
+	      "0000000000000000 0000000000000000",
+	      "D29D576FCEA3A3A7 ED9099F29273D78E",
+	      "B2288B968AE8B086 48D1CE9606FD992D");
   test_cipher(&nettle_serpent192,
-	      HL("0000000000000000 0000000000000000 0000000000000000"),
-	      HL("D29D576FCEABA3A7 ED9899F2927BD78E"),
-	      H("130E353E1037C224 05E8FAEFB2C3C3E9"));
+	      "0000000000000000 0000000000000000 0000000000000000",
+	      "D29D576FCEABA3A7 ED9899F2927BD78E",
+	      "130E353E1037C224 05E8FAEFB2C3C3E9");
   test_cipher(&nettle_serpent256,
-	      HL("0000000000000000 0000000000000000"
-		 "0000000000000000 0000000000000000"),
-	      HL("D095576FCEA3E3A7 ED98D9F29073D78E"),
-	      H("B90EE5862DE69168 F2BDD5125B45472B"));
+	      "0000000000000000 0000000000000000"
+		 "0000000000000000 0000000000000000",
+	      "D095576FCEA3E3A7 ED98D9F29073D78E",
+	      "B90EE5862DE69168 F2BDD5125B45472B");
   test_cipher(&nettle_serpent256,
-	      HL("0000000000000000 0000000000000000"
-		 "0000000000000000 0000000000000000"),
-	      HL("0000000001000000 0200000003000000"),
-	      H("2061A42782BD52EC 691EC383B03BA77C"));
+	      "0000000000000000 0000000000000000"
+		 "0000000000000000 0000000000000000",
+	      "0000000001000000 0200000003000000",
+	      "2061A42782BD52EC 691EC383B03BA77C");
 
   /* The first test for each key size from the ecb_vk.txt and ecb_vt.txt
    * files in the serpent package. */
@@ -53,48 +77,48 @@ test_main(void)
   /* 128 bit key */
 
   /* vk, 1 */
-  test_cipher(&nettle_serpent128,
-	      RHL("8000000000000000 0000000000000000"),
-	      RHL("0000000000000000 0000000000000000"),
-	      RH("49AFBFAD9D5A3405 2CD8FFA5986BD2DD"));
+  test_cipher_reverse(&nettle_serpent128,
+	      "8000000000000000 0000000000000000",
+	      "0000000000000000 0000000000000000",
+	      "49AFBFAD9D5A3405 2CD8FFA5986BD2DD");
 
   /* vt, 1 */
-  test_cipher(&nettle_serpent128,
-	      RHL("0000000000000000 0000000000000000"),
-	      RHL("8000000000000000 0000000000000000"),
-	      RH("10B5FFB720B8CB90 02A1142B0BA2E94A"));
+  test_cipher_reverse(&nettle_serpent128,
+	      "0000000000000000 0000000000000000",
+	      "8000000000000000 0000000000000000",
+	      "10B5FFB720B8CB90 02A1142B0BA2E94A");
 
   /* 192 bit key */
 
   /* vk, 1 */
-  test_cipher(&nettle_serpent192,
-	      RHL("8000000000000000 0000000000000000"
-		 "0000000000000000"),
-	      RHL("0000000000000000 0000000000000000"),
-	      RH("E78E5402C7195568 AC3678F7A3F60C66"));
+  test_cipher_reverse(&nettle_serpent192,
+	      "8000000000000000 0000000000000000"
+		 "0000000000000000",
+	      "0000000000000000 0000000000000000",
+	      "E78E5402C7195568 AC3678F7A3F60C66");
 
   /* vt, 1 */
-  test_cipher(&nettle_serpent192,
-	      RHL("0000000000000000 0000000000000000"
-		 "0000000000000000"),
-	      RHL("8000000000000000 0000000000000000"),
-	      RH("B10B271BA25257E1 294F2B51F076D0D9"));
+  test_cipher_reverse(&nettle_serpent192,
+	      "0000000000000000 0000000000000000"
+		 "0000000000000000",
+	      "8000000000000000 0000000000000000",
+	      "B10B271BA25257E1 294F2B51F076D0D9");
 
   /* 256 bit key */
 
   /* vk, 1 */
-  test_cipher(&nettle_serpent256,
-	      RHL("8000000000000000 0000000000000000"
-		 "0000000000000000 0000000000000000"),
-	      RHL("0000000000000000 0000000000000000"),
-	      RH("ABED96E766BF28CB C0EBD21A82EF0819"));
+  test_cipher_reverse(&nettle_serpent256,
+	      "8000000000000000 0000000000000000"
+		 "0000000000000000 0000000000000000",
+	      "0000000000000000 0000000000000000",
+	      "ABED96E766BF28CB C0EBD21A82EF0819");
 
   /* vt, 1 */
-  test_cipher(&nettle_serpent256,
-	      RHL("0000000000000000 0000000000000000"
-		 "0000000000000000 0000000000000000"),
-	      RHL("8000000000000000 0000000000000000"),
-	      RH("DA5A7992B1B4AE6F 8C004BC8A7DE5520"));
+  test_cipher_reverse(&nettle_serpent256,
+	      "0000000000000000 0000000000000000"
+		 "0000000000000000 0000000000000000",
+	      "8000000000000000 0000000000000000",
+	      "DA5A7992B1B4AE6F 8C004BC8A7DE5520");
 
   /* Test vectors from
      http://www.cs.technion.ac.il/~biham/Reports/Serpent/ */
@@ -102,190 +126,190 @@ test_main(void)
   /* serpent128 */
   /* Set 4, vector#  0 */
   test_cipher(&nettle_serpent128,
-	      HL("000102030405060708090A0B0C0D0E0F"),
-	      HL("00112233445566778899AABBCCDDEEFF"),
-	      H("563E2CF8740A27C164804560391E9B27"));
+	      "000102030405060708090A0B0C0D0E0F",
+	      "00112233445566778899AABBCCDDEEFF",
+	      "563E2CF8740A27C164804560391E9B27");
 
   /* Set 4, vector#  1 */
   test_cipher(&nettle_serpent128,
-	      HL("2BD6459F82C5B300952C49104881FF48"),
-	      HL("EA024714AD5C4D84EA024714AD5C4D84"),
-	      H("92D7F8EF2C36C53409F275902F06539F"));
+	      "2BD6459F82C5B300952C49104881FF48",
+	      "EA024714AD5C4D84EA024714AD5C4D84",
+	      "92D7F8EF2C36C53409F275902F06539F");
 
   /* serpent192 */
   /* Set 4, vector#  0 */
   test_cipher(&nettle_serpent192,
-	      HL("000102030405060708090A0B0C0D0E0F1011121314151617"),
-	      HL("00112233445566778899AABBCCDDEEFF"),
-	      H("6AB816C82DE53B93005008AFA2246A02"));
+	      "000102030405060708090A0B0C0D0E0F1011121314151617",
+	      "00112233445566778899AABBCCDDEEFF",
+	      "6AB816C82DE53B93005008AFA2246A02");
 
   /* Set 4, vector#  1 */
   test_cipher(&nettle_serpent192,
-	      HL("2BD6459F82C5B300952C49104881FF482BD6459F82C5B300"),
-	      HL("EA024714AD5C4D84EA024714AD5C4D84"),
-	      H("827B18C2678A239DFC5512842000E204"));
+	      "2BD6459F82C5B300952C49104881FF482BD6459F82C5B300",
+	      "EA024714AD5C4D84EA024714AD5C4D84",
+	      "827B18C2678A239DFC5512842000E204");
 
   /* serpent256 */
   /* Set 4, vector#  0 */
   test_cipher(&nettle_serpent256,
-	      HL("000102030405060708090A0B0C0D0E0F"
-		 "101112131415161718191A1B1C1D1E1F"),
-	      HL("00112233445566778899AABBCCDDEEFF"),
-	      H("2868B7A2D28ECD5E4FDEFAC3C4330074"));
+	      "000102030405060708090A0B0C0D0E0F"
+		 "101112131415161718191A1B1C1D1E1F",
+	      "00112233445566778899AABBCCDDEEFF",
+	      "2868B7A2D28ECD5E4FDEFAC3C4330074");
 
   /* Set 4, vector#  1 */
   test_cipher(&nettle_serpent256,
-	      HL("2BD6459F82C5B300952C49104881FF48"
-		 "2BD6459F82C5B300952C49104881FF48"),
-	      HL("EA024714AD5C4D84EA024714AD5C4D84"),
-	      H("3E507730776B93FDEA661235E1DD99F0"));
+	      "2BD6459F82C5B300952C49104881FF48"
+		 "2BD6459F82C5B300952C49104881FF48",
+	      "EA024714AD5C4D84EA024714AD5C4D84",
+	      "3E507730776B93FDEA661235E1DD99F0");
 
   /* Test key padding. We use nettle_serpent256, which actually works
      also with key sizes smaller than 32 bytes. */
   test_cipher(&nettle_serpent256,
-	      HL("00112233440100000000000000000000"
-		 "00000000000000000000000000000000"),
-	      HL("0000000001000000 0200000003000000"),
-	      H("C1415AC653FD7C7F D917482EE8EBFE25"));
+	      "00112233440100000000000000000000"
+		 "00000000000000000000000000000000",
+	      "0000000001000000 0200000003000000",
+	      "C1415AC653FD7C7F D917482EE8EBFE25");
 
   /* Currrently, key sizes smaller than SERPENT_MIN_KEY_SIZE bytes
      (128 bits) are not supported. */
   test_cipher(&nettle_serpent256,
-	      HL("0011223344"),
-	      HL("0000000001000000 0200000003000000"),
-	      H("C1415AC653FD7C7F D917482EE8EBFE25"));
+	      "0011223344",
+	      "0000000001000000 0200000003000000",
+	      "C1415AC653FD7C7F D917482EE8EBFE25");
 
   test_cipher(&nettle_serpent256,
-	      HL("00112233445566778899aabbccddeeff"
-		 "00010000000000000000000000000000"),
-	      HL("0000000001000000 0200000003000000"),
-	      H("8EB9C958EAFFDF42 009755D7B6458838"));
+	      "00112233445566778899aabbccddeeff"
+		 "00010000000000000000000000000000",
+	      "0000000001000000 0200000003000000",
+	      "8EB9C958EAFFDF42 009755D7B6458838");
 
   test_cipher(&nettle_serpent256,
-	      HL("00112233445566778899aabbccddeeff"
-		 "00"),
-	      HL("0000000001000000 0200000003000000"),
-	      H("8EB9C958EAFFDF42 009755D7B6458838"));
+	      "00112233445566778899aabbccddeeff"
+		 "00",
+	      "0000000001000000 0200000003000000",
+	      "8EB9C958EAFFDF42 009755D7B6458838");
 
   test_cipher(&nettle_serpent256,
-	      HL("00112233445566778899aabbccddeeff"
-		 "00112201000000000000000000000000"),
-	      HL("0000000001000000 0200000003000000"),
-	      H("C8A078D8212AC96D 9060E30EC5CBB5C7"));
+	      "00112233445566778899aabbccddeeff"
+		 "00112201000000000000000000000000",
+	      "0000000001000000 0200000003000000",
+	      "C8A078D8212AC96D 9060E30EC5CBB5C7");
 
   test_cipher(&nettle_serpent256,
-	      HL("00112233445566778899aabbccddeeff"
-		 "001122"),
-	      HL("0000000001000000 0200000003000000"),
-	      H("C8A078D8212AC96D 9060E30EC5CBB5C7"));
+	      "00112233445566778899aabbccddeeff"
+		 "001122",
+	      "0000000001000000 0200000003000000",
+	      "C8A078D8212AC96D 9060E30EC5CBB5C7");
 
   /* Test with multiple blocks. */
   test_cipher(&nettle_serpent128,
-	      HL("e87450aa0fd87293fd0371483a459bd2"),
-	      HL("a78a7a8d392f629d bd13674c8dce6fa2"),
-	      H("b3d488986c80dea7 c5ebdab4907871c9"));
+	      "e87450aa0fd87293fd0371483a459bd2",
+	      "a78a7a8d392f629d bd13674c8dce6fa2",
+	      "b3d488986c80dea7 c5ebdab4907871c9");
 
   test_cipher(&nettle_serpent128,
-	      HL("e87450aa0fd87293fd0371483a459bd2"),
-	      HL("a78a7a8d392f629d bd13674c8dce6fa2"
-		 "930c74dec02a11d8 c80d90b5e5c887a7"),
-	      H("b3d488986c80dea7 c5ebdab4907871c9"
-		"a4b92b13b79afb37 5518b01bfd706a37"));
+	      "e87450aa0fd87293fd0371483a459bd2",
+	      "a78a7a8d392f629d bd13674c8dce6fa2"
+		 "930c74dec02a11d8 c80d90b5e5c887a7",
+	      "b3d488986c80dea7 c5ebdab4907871c9"
+		"a4b92b13b79afb37 5518b01bfd706a37");
 
   test_cipher(&nettle_serpent128,
-	      HL("e87450aa0fd87293fd0371483a459bd2"),
-	      HL("a78a7a8d392f629d bd13674c8dce6fa2"
+	      "e87450aa0fd87293fd0371483a459bd2",
+	      "a78a7a8d392f629d bd13674c8dce6fa2"
 		 "930c74dec02a11d8 c80d90b5e5c887a7"
-		 "83c92a921b5b2028 d9cb313a5f07ab09"),
-	      H("b3d488986c80dea7 c5ebdab4907871c9"
+		 "83c92a921b5b2028 d9cb313a5f07ab09",
+	      "b3d488986c80dea7 c5ebdab4907871c9"
 		"a4b92b13b79afb37 5518b01bfd706a37"
-		"8e44c2d463df4531 165461699edbad03"));
+		"8e44c2d463df4531 165461699edbad03");
 
   test_cipher(&nettle_serpent128,
-	      HL("91c8e949e12f0e38 7b2473238a3df1b6"),
-	      HL("00000000 00000001 00000002 00000003"
+	      "91c8e949e12f0e38 7b2473238a3df1b6",
+	      "00000000 00000001 00000002 00000003"
 		 "00000004 00000005 00000006 00000007"
 		 "00000008 00000009 0000000a 0000000b"
-		 "0000000c 0000000d 0000000e 0000000f"),
-	      H("2db9f0a39d4f31a4 b1a83cd1032fe1bd"
+		 "0000000c 0000000d 0000000e 0000000f",
+	      "2db9f0a39d4f31a4 b1a83cd1032fe1bd"
 		"3606caa84a220b1b f6f43ff80a831203"
 		"8c6c8d2793dc10b3 904d30e194f086a6"
-		"b2f3e932b9b3f8d1 d4d074f7bd1ff7a3"));
+		"b2f3e932b9b3f8d1 d4d074f7bd1ff7a3");
 	      
   test_cipher(&nettle_serpent128,
-	      HL("e87450aa0fd87293fd0371483a459bd2"),
-	      HL("a78a7a8d392f629d bd13674c8dce6fa2"
+	      "e87450aa0fd87293fd0371483a459bd2",
+	      "a78a7a8d392f629d bd13674c8dce6fa2"
 		 "930c74dec02a11d8 c80d90b5e5c887a7"
 		 "83c92a921b5b2028 d9cb313a5f07ab09"
-		 "672eadf1624a2ed0 c42d1b08b076f75a"),
-	      H("b3d488986c80dea7 c5ebdab4907871c9"
+		 "672eadf1624a2ed0 c42d1b08b076f75a",
+	      "b3d488986c80dea7 c5ebdab4907871c9"
 		"a4b92b13b79afb37 5518b01bfd706a37"
 		"8e44c2d463df4531 165461699edbad03"
-		"30ac8c52697102ae 3b725dba79ceb250"));
+		"30ac8c52697102ae 3b725dba79ceb250");
 
   test_cipher(&nettle_serpent128,
-	      HL("e87450aa0fd87293fd0371483a459bd2"),
-	      HL("a78a7a8d392f629d bd13674c8dce6fa2"
+	      "e87450aa0fd87293fd0371483a459bd2",
+	      "a78a7a8d392f629d bd13674c8dce6fa2"
 		 "930c74dec02a11d8 c80d90b5e5c887a7"
 		 "83c92a921b5b2028 d9cb313a5f07ab09"
 		 "672eadf1624a2ed0 c42d1b08b076f75a"
-		 "7378272aa57ad7c8 803e326689541266"),
-	      H("b3d488986c80dea7 c5ebdab4907871c9"
+		 "7378272aa57ad7c8 803e326689541266",
+	      "b3d488986c80dea7 c5ebdab4907871c9"
 		"a4b92b13b79afb37 5518b01bfd706a37"
 		"8e44c2d463df4531 165461699edbad03"
 		"30ac8c52697102ae 3b725dba79ceb250"
-		"d308b83478e86dbb 629f18736cca042f"));
+		"d308b83478e86dbb 629f18736cca042f");
 
   test_cipher(&nettle_serpent128,
-	      HL("e87450aa0fd87293fd0371483a459bd2"),
-	      HL("a78a7a8d392f629d bd13674c8dce6fa2"
+	      "e87450aa0fd87293fd0371483a459bd2",
+	      "a78a7a8d392f629d bd13674c8dce6fa2"
 		 "930c74dec02a11d8 c80d90b5e5c887a7"
 		 "83c92a921b5b2028 d9cb313a5f07ab09"
 		 "672eadf1624a2ed0 c42d1b08b076f75a"
 		 "7378272aa57ad7c8 803e326689541266"
-		 "b7a2efda5721776f 4113d63a702ac3ae"),
-	      H("b3d488986c80dea7 c5ebdab4907871c9"
+		 "b7a2efda5721776f 4113d63a702ac3ae",
+	      "b3d488986c80dea7 c5ebdab4907871c9"
 		"a4b92b13b79afb37 5518b01bfd706a37"
 		"8e44c2d463df4531 165461699edbad03"
 		"30ac8c52697102ae 3b725dba79ceb250"
 		"d308b83478e86dbb 629f18736cca042f"
-		"006b89e494469adf 0ee78c60684dff86"));
+		"006b89e494469adf 0ee78c60684dff86");
     
   test_cipher(&nettle_serpent128,
-	      HL("e87450aa0fd87293fd0371483a459bd2"),
-	      HL("a78a7a8d392f629d bd13674c8dce6fa2"
+	      "e87450aa0fd87293fd0371483a459bd2",
+	      "a78a7a8d392f629d bd13674c8dce6fa2"
 		 "930c74dec02a11d8 c80d90b5e5c887a7"
 		 "83c92a921b5b2028 d9cb313a5f07ab09"
 		 "672eadf1624a2ed0 c42d1b08b076f75a"
 		 "7378272aa57ad7c8 803e326689541266"
 		 "b7a2efda5721776f 4113d63a702ac3ae"
-		 "cd1be7bbfad74819 644617f8656e9e5b"),
-	      H("b3d488986c80dea7 c5ebdab4907871c9"
+		 "cd1be7bbfad74819 644617f8656e9e5b",
+	      "b3d488986c80dea7 c5ebdab4907871c9"
 		"a4b92b13b79afb37 5518b01bfd706a37"
 		"8e44c2d463df4531 165461699edbad03"
 		"30ac8c52697102ae 3b725dba79ceb250"
 		"d308b83478e86dbb 629f18736cca042f"
 		"006b89e494469adf 0ee78c60684dff86"
-		"5f2c99908ee77ffe aea3d30cb78a1ce1"));
+		"5f2c99908ee77ffe aea3d30cb78a1ce1");
 
   test_cipher(&nettle_serpent128,
-	      HL("e87450aa0fd87293fd0371483a459bd2"),
-	      HL("a78a7a8d392f629d bd13674c8dce6fa2"
+	      "e87450aa0fd87293fd0371483a459bd2",
+	      "a78a7a8d392f629d bd13674c8dce6fa2"
 		 "930c74dec02a11d8 c80d90b5e5c887a7"
 		 "83c92a921b5b2028 d9cb313a5f07ab09"
 		 "672eadf1624a2ed0 c42d1b08b076f75a"
 		 "7378272aa57ad7c8 803e326689541266"
 		 "b7a2efda5721776f 4113d63a702ac3ae"
 		 "cd1be7bbfad74819 644617f8656e9e5b"
-		 "34d449409c1f850a 4cb6700d6ef3405f"),
-	      H("b3d488986c80dea7 c5ebdab4907871c9"
+		 "34d449409c1f850a 4cb6700d6ef3405f",
+	      "b3d488986c80dea7 c5ebdab4907871c9"
 		"a4b92b13b79afb37 5518b01bfd706a37"
 		"8e44c2d463df4531 165461699edbad03"
 		"30ac8c52697102ae 3b725dba79ceb250"
 		"d308b83478e86dbb 629f18736cca042f"
 		"006b89e494469adf 0ee78c60684dff86"
 		"5f2c99908ee77ffe aea3d30cb78a1ce1"
-		"ebe855dd51532477 4d2d55969e032e6c"));
+		"ebe855dd51532477 4d2d55969e032e6c");
 
   SUCCESS();
 }
diff --git a/testsuite/sexp-format-test.c b/testsuite/sexp-format-test.c
index 33c585f..4136693 100644
--- a/testsuite/sexp-format-test.c
+++ b/testsuite/sexp-format-test.c
@@ -26,6 +26,7 @@ test_main(void)
     
     ASSERT(buffer.size == strlen(e));
     ASSERT(MEMEQ(buffer.size, buffer.contents, e));
+    nettle_buffer_clear(&buffer);
   }
   {
     const uint8_t e[] = "{KDM6Zm9vKDM6YmFyMTc6eHh4eHh4eHh4eHh4eHh4eHgpKQ==}";
@@ -41,6 +42,7 @@ test_main(void)
     
     ASSERT(buffer.size == strlen(e));
     ASSERT(MEMEQ(buffer.size, buffer.contents, e));
+    nettle_buffer_clear(&buffer);
   }
   {
     const uint8_t e[] = "1:\0""1:a2:bc3:def4:ghij5:\x00\xDE\xAD\xBE\xEF";
@@ -52,6 +54,7 @@ test_main(void)
     
     ASSERT(buffer.size == LLENGTH(e));
     ASSERT(MEMEQ(buffer.size, buffer.contents, e));
+    nettle_buffer_clear(&buffer);
   }
 
   {
@@ -64,6 +67,8 @@ test_main(void)
     
     ASSERT(buffer.size == strlen(e));
     ASSERT(MEMEQ(buffer.size, buffer.contents, e));
+
+    nettle_buffer_clear(&buffer);
   }
 
   {
@@ -75,6 +80,7 @@ test_main(void)
 	   == strlen(e));
 
     ASSERT(MEMEQ(buffer.size, buffer.contents, e));
+    nettle_buffer_clear(&buffer);
   }
 
   /* Try literals */
@@ -92,6 +98,7 @@ test_main(void)
     
     ASSERT(buffer.size == strlen(e));
     ASSERT(MEMEQ(buffer.size, buffer.contents, e));
+    nettle_buffer_clear(&buffer);
   }
   {
     const uint8_t e[] = "(3:foo(3:bar17:xxxxxxxxxxxxxxxxx))";
@@ -107,6 +114,7 @@ test_main(void)
     
     ASSERT(buffer.size == strlen(e));
     ASSERT(MEMEQ(buffer.size, buffer.contents, e));
+    nettle_buffer_clear(&buffer);
   }
 
   /* Literal parenthesis */
@@ -122,6 +130,7 @@ test_main(void)
     
     ASSERT(buffer.size == strlen(e));
     ASSERT(MEMEQ(buffer.size, buffer.contents, e));
+    nettle_buffer_clear(&buffer);
   }
   
 #if HAVE_LIBGMP
@@ -133,7 +142,7 @@ test_main(void)
     const uint8_t e[] =
       "(3:foo(3:bar1:\xff""11:abcdefghijk13:\0\x81""abcdefghijk))";
 
-    nettle_buffer_clear(&buffer);
+//    nettle_buffer_clear(&buffer);
 
     mpz_init_set_si(x, -1);
     nettle_mpz_init_set_str_256_u(y, 11, "abcdefghijk");
@@ -153,6 +162,8 @@ test_main(void)
 
     nettle_buffer_clear(&buffer);
     mpz_clear(x);
+    mpz_clear(y);
+    mpz_clear(z);
   }
 #endif /* HAVE_LIBGMP */
 
diff --git a/testsuite/sexp-test.c b/testsuite/sexp-test.c
index 4e68f56..0fdec10 100644
--- a/testsuite/sexp-test.c
+++ b/testsuite/sexp-test.c
@@ -1,12 +1,15 @@
 #include "testutils.h"
 #include "sexp.h"
 
+#define INPUT "{Mzpmb28=} {MDo=} {WzM6YmFyXTEyOnh4eHh4eHh4eHh4eA==}"
+
 int
 test_main(void)
 {
   struct sexp_iterator i;
   uint32_t x;
-  
+  uint8_t *p;
+
   ASSERT(sexp_iterator_first(&i, LDATA("")));
   ASSERT(i.type == SEXP_END);
 
@@ -49,9 +52,9 @@ test_main(void)
 	 && sexp_iterator_next(&i) && i.type == SEXP_END);
   
   /* Same data, transport encoded. */
-  
+
   ASSERT(sexp_transport_iterator_first
-	 (&i, LDUP("{Mzpmb28=} {MDo=} {WzM6YmFyXTEyOnh4eHh4eHh4eHh4eA==}")));
+	 (&i, sizeof(INPUT) - 1, p=strdup(INPUT)));
   ASSERT(i.type == SEXP_ATOM
 	 && !i.display_length && !i.display
 	 && i.atom_length == 3 && MEMEQ(3, "foo", i.atom)
@@ -95,5 +98,7 @@ test_main(void)
 	   && !sexp_iterator_assoc(&i, 2, keys, v));    
   }
 
+  free((void *)p);
+
   SUCCESS();
 }
diff --git a/testsuite/sexp2rsa-test.c b/testsuite/sexp2rsa-test.c
index 2e7cd91..3555e1e 100644
--- a/testsuite/sexp2rsa-test.c
+++ b/testsuite/sexp2rsa-test.c
@@ -3,15 +3,8 @@
 int
 test_main(void)
 {
-  struct rsa_public_key pub;
-  struct rsa_private_key priv;
-  
-  rsa_public_key_init(&pub);
-  rsa_private_key_init(&priv);
-
-  ASSERT(rsa_keypair_from_sexp
-	 (&pub, &priv, 0,
-	  HL("2831313a707269766174652d6b657928"
+  static const uint8_t *expr_hex =
+	  "2831313a707269766174652d6b657928"
 	     "333a72736128313a6e36333a085c3408"
 	     "989acae4faec3cbbad91c90d34c1d259"
 	     "cd74121a36f38b0b51424a9b2be514a0"
@@ -34,12 +27,24 @@ test_main(void)
 	     "1d068e2ce9f565c5528c4a7473292831"
 	     "3a6333323a00f8a458ea73a018dc6fa5"
 	     "6863e3bc6de405f364f77dee6f096267"
-	     "9ea1a8282e292929")));
+	     "9ea1a8282e292929";
+  unsigned expr_length = decode_hex_length(expr_hex);
+  const uint8_t *expr = decode_hex_dup(expr_hex);
+  struct rsa_public_key pub;
+  struct rsa_private_key priv;
+  
+  rsa_public_key_init(&pub);
+  rsa_private_key_init(&priv);
+
+  ASSERT(rsa_keypair_from_sexp
+	 (&pub, &priv, 0, expr_length, expr));
 
   test_rsa_key(&pub, &priv);
 
   rsa_public_key_clear(&pub);
   rsa_private_key_clear(&priv);
+
+  free((void *)expr);
   
   SUCCESS();
 }
diff --git a/testsuite/sha1-test.c b/testsuite/sha1-test.c
index 8319086..7b6439a 100644
--- a/testsuite/sha1-test.c
+++ b/testsuite/sha1-test.c
@@ -4,34 +4,34 @@
 int
 test_main(void)
 {
-  test_hash(&nettle_sha1, 0, "",
-	    H("DA39A3EE5E6B4B0D 3255BFEF95601890 AFD80709")); 
+  test_hash(&nettle_sha1, "",
+	    "DA39A3EE5E6B4B0D 3255BFEF95601890 AFD80709"); 
 
-  test_hash(&nettle_sha1, 1, "a",
-	    H("86F7E437FAA5A7FC E15D1DDCB9EAEAEA 377667B8")); 
+  test_hash(&nettle_sha1, "a",
+	    "86F7E437FAA5A7FC E15D1DDCB9EAEAEA 377667B8"); 
 
-  test_hash(&nettle_sha1, 3, "abc",
-	    H("A9993E364706816A BA3E25717850C26C 9CD0D89D"));
+  test_hash(&nettle_sha1, "abc",
+	    "A9993E364706816A BA3E25717850C26C 9CD0D89D");
   
-  test_hash(&nettle_sha1, 26, "abcdefghijklmnopqrstuvwxyz",
-	    H("32D10C7B8CF96570 CA04CE37F2A19D84 240D3A89"));
+  test_hash(&nettle_sha1, "abcdefghijklmnopqrstuvwxyz",
+	    "32D10C7B8CF96570 CA04CE37F2A19D84 240D3A89");
   
-  test_hash(&nettle_sha1, 14, "message digest",
-	    H("C12252CEDA8BE899 4D5FA0290A47231C 1D16AAE3")); 
+  test_hash(&nettle_sha1, "message digest",
+	    "C12252CEDA8BE899 4D5FA0290A47231C 1D16AAE3"); 
 
-  test_hash(&nettle_sha1, 62,
+  test_hash(&nettle_sha1,
 	    "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
 	    "abcdefghijklmnopqrstuvwxyz0123456789",
-	    H("761C457BF73B14D2 7E9E9265C46F4B4D DA11F940"));
+	    "761C457BF73B14D2 7E9E9265C46F4B4D DA11F940");
   
-  test_hash(&nettle_sha1,  80,
+  test_hash(&nettle_sha1,
 	    "1234567890123456789012345678901234567890"
 	    "1234567890123456789012345678901234567890",
-	    H("50ABF5706A150990 A08B2C5EA40FA0E5 85554732"));
+	    "50ABF5706A150990 A08B2C5EA40FA0E5 85554732");
 
   /* Additional test vector, from Daniel Kahn Gillmor */
-  test_hash(&nettle_sha1, LDATA("38"),
-	    H("5b384ce32d8cdef02bc3a139d4cac0a22bb029e8"));
+  test_hash(&nettle_sha1, "38",
+	    "5b384ce32d8cdef02bc3a139d4cac0a22bb029e8");
 
   SUCCESS();
 }
diff --git a/testsuite/sha224-test.c b/testsuite/sha224-test.c
index cef82af..fef7d47 100644
--- a/testsuite/sha224-test.c
+++ b/testsuite/sha224-test.c
@@ -6,43 +6,43 @@ test_main(void)
 {
   /* From FIPS180-2 addendum
      (http://csrc.nist.gov/publications/fips/fips180-2/fips180-2withchangenotice.pdf) */
-  test_hash(&nettle_sha224, 3, "abc",
-	    H("23097d22 3405d822 8642a477 bda255b3"
-	      "2aadbce4 bda0b3f7 e36c9da7"));
+  test_hash(&nettle_sha224, "abc",
+	    "23097d22 3405d822 8642a477 bda255b3"
+	      "2aadbce4 bda0b3f7 e36c9da7");
 
-  test_hash(&nettle_sha224, 56,
+  test_hash(&nettle_sha224,
 	    "abcdbcdecdefdefgefghfghighij"
 	    "hijkijkljklmklmnlmnomnopnopq",
-	    H("75388b16 512776cc 5dba5da1 fd890150"
-	      "b0c6455c b4f58b19 52522525"));
+	    "75388b16 512776cc 5dba5da1 fd890150"
+	      "b0c6455c b4f58b19 52522525");
 
   /* Additional test vectors, from Daniel Kahn Gillmor */
-  test_hash(&nettle_sha224, LDATA(""),
-	    H("d14a028c2a3a2bc9 476102bb288234c4"
-	      "15a2b01f828ea62a c5b3e42f"));
-  test_hash(&nettle_sha224, LDATA("a"),
-	    H("abd37534c7d9a2ef b9465de931cd7055"
-	      "ffdb8879563ae980 78d6d6d5"));
-  test_hash(&nettle_sha224, LDATA("38"),
-	    H("4cfca6da32da6471 98225460722b7ea1"
-	      "284f98c4b179e8db ae3f93d5"));
-  test_hash(&nettle_sha224, LDATA("message digest"),
-	    H("2cb21c83ae2f004d e7e81c3c7019cbcb"
-	      "65b71ab656b22d6d 0c39b8eb"));
-  test_hash(&nettle_sha224, LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("45a5f72c39c5cff2 522eb3429799e49e"
-	      "5f44b356ef926bcf 390dccc2"));
+  test_hash(&nettle_sha224, "",
+	    "d14a028c2a3a2bc9 476102bb288234c4"
+	      "15a2b01f828ea62a c5b3e42f");
+  test_hash(&nettle_sha224, "a",
+	    "abd37534c7d9a2ef b9465de931cd7055"
+	      "ffdb8879563ae980 78d6d6d5");
+  test_hash(&nettle_sha224, "38",
+	    "4cfca6da32da6471 98225460722b7ea1"
+	      "284f98c4b179e8db ae3f93d5");
+  test_hash(&nettle_sha224, "message digest",
+	    "2cb21c83ae2f004d e7e81c3c7019cbcb"
+	      "65b71ab656b22d6d 0c39b8eb");
+  test_hash(&nettle_sha224, "abcdefghijklmnopqrstuvwxyz",
+	    "45a5f72c39c5cff2 522eb3429799e49e"
+	      "5f44b356ef926bcf 390dccc2");
   test_hash(&nettle_sha224,
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef"
-		  "ghijklmnopqrstuvwxyz0123456789"),
-	    H("bff72b4fcb7d75e5 632900ac5f90d219"
-	      "e05e97a7bde72e74 0db393d9"));
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef"
+		  "ghijklmnopqrstuvwxyz0123456789",
+	    "bff72b4fcb7d75e5 632900ac5f90d219"
+	      "e05e97a7bde72e74 0db393d9");
   test_hash(&nettle_sha224,
-	    LDATA("12345678901234567890123456789012"
+	    "12345678901234567890123456789012"
 		  "34567890123456789012345678901234"
-		  "5678901234567890"),
-	    H("b50aecbe4e9bb0b5 7bc5f3ae760a8e01"
-	      "db24f203fb3cdcd1 3148046e"));
+		  "5678901234567890",
+	    "b50aecbe4e9bb0b5 7bc5f3ae760a8e01"
+	      "db24f203fb3cdcd1 3148046e");
 
   SUCCESS();
 }
diff --git a/testsuite/sha256-test.c b/testsuite/sha256-test.c
index 7499521..b113419 100644
--- a/testsuite/sha256-test.c
+++ b/testsuite/sha256-test.c
@@ -5,51 +5,51 @@ int
 test_main(void)
 {
   /* From FIPS180-2 */
-  test_hash(&nettle_sha256, 3, "abc",
-	    H("ba7816bf8f01cfea 414140de5dae2223"
-	      "b00361a396177a9c b410ff61f20015ad"));
+  test_hash(&nettle_sha256, "abc",
+	    "ba7816bf8f01cfea 414140de5dae2223"
+	      "b00361a396177a9c b410ff61f20015ad");
 
-  test_hash(&nettle_sha256, 56,
+  test_hash(&nettle_sha256,
 	    "abcdbcdecdefdefgefghfghighij"
 	    "hijkijkljklmklmnlmnomnopnopq",
-	    H("248d6a61d20638b8 e5c026930c3e6039"
-	      "a33ce45964ff2167 f6ecedd419db06c1"));
+	    "248d6a61d20638b8 e5c026930c3e6039"
+	      "a33ce45964ff2167 f6ecedd419db06c1");
 
-  test_hash(&nettle_sha256, 112,
+  test_hash(&nettle_sha256,
 	    "abcdefghbcdefghicdefghijdefg"
 	    "hijkefghijklfghijklmghijklmn"
 	    "hijklmnoijklmnopjklmnopqklmn"
 	    "opqrlmnopqrsmnopqrstnopqrstu",
-	    H("cf5b16a778af8380 036ce59e7b049237"
-	      "0b249b11e8f07a51 afac45037afee9d1"));
+	    "cf5b16a778af8380 036ce59e7b049237"
+	      "0b249b11e8f07a51 afac45037afee9d1");
 
   /* Additional test vectors, from Daniel Kahn Gillmor */
-  test_hash(&nettle_sha256, LDATA(""),
-	    H("e3b0c44298fc1c14 9afbf4c8996fb924"
-	      "27ae41e4649b934c a495991b7852b855"));
-  test_hash(&nettle_sha256, LDATA("a"),
-	    H("ca978112ca1bbdca fac231b39a23dc4d"
-	      "a786eff8147c4e72 b9807785afee48bb"));
-  test_hash(&nettle_sha256, LDATA("38"),
-	    H("aea92132c4cbeb26 3e6ac2bf6c183b5d"
-	      "81737f179f21efdc 5863739672f0f470"));
-  test_hash(&nettle_sha256, LDATA("message digest"),
-	    H("f7846f55cf23e14e ebeab5b4e1550cad"
-	      "5b509e3348fbc4ef a3a1413d393cb650"));
-  test_hash(&nettle_sha256, LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("71c480df93d6ae2f 1efad1447c66c952"
-	      "5e316218cf51fc8d 9ed832f2daf18b73"));
+  test_hash(&nettle_sha256, "",
+	    "e3b0c44298fc1c14 9afbf4c8996fb924"
+	      "27ae41e4649b934c a495991b7852b855");
+  test_hash(&nettle_sha256, "a",
+	    "ca978112ca1bbdca fac231b39a23dc4d"
+	      "a786eff8147c4e72 b9807785afee48bb");
+  test_hash(&nettle_sha256, "38",
+	    "aea92132c4cbeb26 3e6ac2bf6c183b5d"
+	      "81737f179f21efdc 5863739672f0f470");
+  test_hash(&nettle_sha256, "message digest",
+	    "f7846f55cf23e14e ebeab5b4e1550cad"
+	      "5b509e3348fbc4ef a3a1413d393cb650");
+  test_hash(&nettle_sha256, "abcdefghijklmnopqrstuvwxyz",
+	    "71c480df93d6ae2f 1efad1447c66c952"
+	      "5e316218cf51fc8d 9ed832f2daf18b73");
   test_hash(&nettle_sha256,
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef"
-		  "ghijklmnopqrstuvwxyz0123456789"),
-	    H("db4bfcbd4da0cd85 a60c3c37d3fbd880"
-	      "5c77f15fc6b1fdfe 614ee0a7c8fdb4c0"));
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef"
+		  "ghijklmnopqrstuvwxyz0123456789",
+	    "db4bfcbd4da0cd85 a60c3c37d3fbd880"
+	      "5c77f15fc6b1fdfe 614ee0a7c8fdb4c0");
   test_hash(&nettle_sha256,
-	    LDATA("12345678901234567890123456789012"
+	    "12345678901234567890123456789012"
 		  "34567890123456789012345678901234"
-		  "5678901234567890"),
-	    H("f371bc4a311f2b00 9eef952dd83ca80e"
-	      "2b60026c8e935592 d0f9c308453c813e"));
+		  "5678901234567890",
+	    "f371bc4a311f2b00 9eef952dd83ca80e"
+	      "2b60026c8e935592 d0f9c308453c813e");
 
   SUCCESS();
 }
